/* This file has been generated by the Perl script `afblue.pl', */
/* using data from file `afblue.dat'.                           */

/***************************************************************************/
/*                                                                         */
/*  afblue.h                                                               */
/*                                                                         */
/*    Auto-fitter data for blue strings (specification).                   */
/*                                                                         */
/*  Copyright 2013-2017 by                                                 */
/*  David Turner, Robert Wilhelm, and Werner Lemberg.                      */
/*                                                                         */
/*  This file is part of the FreeType project, and may only be used,       */
/*  modified, and distributed under the terms of the FreeType project      */
/*  license, LICENSE.TXT.  By continuing to use, modify, or distribute     */
/*  this file you indicate that you have read the license and              */
/*  understand and accept it fully.                                        */
/*                                                                         */
/***************************************************************************/


#ifndef AFBLUE_H_
#define AFBLUE_H_


FT_BEGIN_HEADER


  /* an auxiliary macro to decode a UTF-8 character -- since we only use */
  /* hard-coded, self-converted data, no error checking is performed     */
#define GET_UTF8_CHAR( ch, p )                      \
          do                                        \
          {                                         \
            ch = (unsigned char)*p++;               \
            if ( ch >= 0x80 )                       \
            {                                       \
              FT_UInt  len_;                        \
                                                    \
                                                    \
              if ( ch < 0xE0 )                      \
              {                                     \
                len_ = 1;                           \
                ch  &= 0x1F;                        \
              }                                     \
              else if ( ch < 0xF0 )                 \
              {                                     \
                len_ = 2;                           \
                ch  &= 0x0F;                        \
              }                                     \
              else                                  \
              {                                     \
                len_ = 3;                           \
                ch  &= 0x07;                        \
              }                                     \
                                                    \
              for ( ; len_ > 0; len_-- )            \
                ch = ( ch << 6 ) | ( *p++ & 0x3F ); \
            }                                       \
          } while ( 0 )


  /*************************************************************************/
  /*************************************************************************/
  /*****                                                               *****/
  /*****                    B L U E   S T R I N G S                    *****/
  /*****                                                               *****/
  /*************************************************************************/
  /*************************************************************************/

  /* At the bottommost level, we define strings for finding blue zones. */


#define AF_BLUE_STRING_MAX_LEN  51

  /* The AF_Blue_String enumeration values are offsets into the */
  /* `af_blue_strings' array.                                   */

  typedef enum  AF_Blue_String_
  {
    AF_BLUE_STRING_ADLAM_CAPITAL_TOP = 0,
    AF_BLUE_STRING_ADLAM_CAPITAL_BOTTOM = 30,
    AF_BLUE_STRING_ADLAM_SMALL_TOP = 40,
    AF_BLUE_STRING_ADLAM_SMALL_BOTTOM = 65,
    AF_BLUE_STRING_ARABIC_TOP = 105,
    AF_BLUE_STRING_ARABIC_BOTTOM = 123,
    AF_BLUE_STRING_ARABIC_JOIN = 138,
    AF_BLUE_STRING_ARMENIAN_CAPITAL_TOP = 141,
    AF_BLUE_STRING_ARMENIAN_CAPITAL_BOTTOM = 165,
    AF_BLUE_STRING_ARMENIAN_SMALL_ASCENDER = 189,
    AF_BLUE_STRING_ARMENIAN_SMALL_TOP = 210,
    AF_BLUE_STRING_ARMENIAN_SMALL_BOTTOM = 234,
    AF_BLUE_STRING_ARMENIAN_SMALL_DESCENDER = 258,
    AF_BLUE_STRING_AVESTAN_TOP = 282,
    AF_BLUE_STRING_AVESTAN_BOTTOM = 302,
    AF_BLUE_STRING_BAMUM_TOP = 312,
    AF_BLUE_STRING_BAMUM_BOTTOM = 344,
    AF_BLUE_STRING_BENGALI_BASE = 376,
    AF_BLUE_STRING_BENGALI_TOP = 408,
    AF_BLUE_STRING_BENGALI_HEAD = 436,
    AF_BLUE_STRING_BUHID_TOP = 468,
    AF_BLUE_STRING_BUHID_LARGE = 476,
    AF_BLUE_STRING_BUHID_SMALL = 488,
    AF_BLUE_STRING_BUHID_BOTTOM = 504,
    AF_BLUE_STRING_CANADIAN_SYLLABICS_TOP = 532,
    AF_BLUE_STRING_CANADIAN_SYLLABICS_BOTTOM = 564,
    AF_BLUE_STRING_CANADIAN_SYLLABICS_SMALL_TOP = 596,
    AF_BLUE_STRING_CANADIAN_SYLLABICS_SMALL_BOTTOM = 628,
    AF_BLUE_STRING_CANADIAN_SYLLABICS_SUPS_TOP = 660,
    AF_BLUE_STRING_CANADIAN_SYLLABICS_SUPS_BOTTOM = 688,
    AF_BLUE_STRING_CARIAN_TOP = 720,
    AF_BLUE_STRING_CARIAN_BOTTOM = 760,
    AF_BLUE_STRING_CHEROKEE_CAPITAL = 795,
    AF_BLUE_STRING_CHEROKEE_SMALL_ASCENDER = 827,
    AF_BLUE_STRING_CHEROKEE_SMALL = 859,
    AF_BLUE_STRING_CHEROKEE_SMALL_DESCENDER = 891,
    AF_BLUE_STRING_COPTIC_CAPITAL_TOP = 907,
    AF_BLUE_STRING_COPTIC_CAPITAL_BOTTOM = 939,
    AF_BLUE_STRING_COPTIC_SMALL_TOP = 971,
    AF_BLUE_STRING_COPTIC_SMALL_BOTTOM = 1003,
    AF_BLUE_STRING_CYPRIOT_TOP = 1035,
    AF_BLUE_STRING_CYPRIOT_BOTTOM = 1075,
    AF_BLUE_STRING_CYPRIOT_SMALL = 1110,
    AF_BLUE_STRING_CYRILLIC_CAPITAL_TOP = 1125,
    AF_BLUE_STRING_CYRILLIC_CAPITAL_BOTTOM = 1149,
    AF_BLUE_STRING_CYRILLIC_SMALL = 1173,
    AF_BLUE_STRING_CYRILLIC_SMALL_DESCENDER = 1197,
    AF_BLUE_STRING_DESERET_CAPITAL_TOP = 1206,
    AF_BLUE_STRING_DESERET_CAPITAL_BOTTOM = 1231,
    AF_BLUE_STRING_DESERET_SMALL_TOP = 1256,
    AF_BLUE_STRING_DESERET_SMALL_BOTTOM = 1281,
    AF_BLUE_STRING_DEVANAGARI_BASE = 1306,
    AF_BLUE_STRING_DEVANAGARI_TOP = 1338,
    AF_BLUE_STRING_DEVANAGARI_HEAD = 1370,
    AF_BLUE_STRING_DEVANAGARI_BOTTOM = 1402,
    AF_BLUE_STRING_ETHIOPIC_TOP = 1410,
    AF_BLUE_STRING_ETHIOPIC_BOTTOM = 1442,
    AF_BLUE_STRING_GEORGIAN_MKHEDRULI_TOP = 1474,
    AF_BLUE_STRING_GEORGIAN_MKHEDRULI_BOTTOM = 1506,
    AF_BLUE_STRING_GEORGIAN_MKHEDRULI_ASCENDER = 1538,
    AF_BLUE_STRING_GEORGIAN_MKHEDRULI_DESCENDER = 1570,
    AF_BLUE_STRING_GEORGIAN_ASOMTAVRULI_TOP = 1602,
    AF_BLUE_STRING_GEORGIAN_ASOMTAVRULI_BOTTOM = 1634,
    AF_BLUE_STRING_GEORGIAN_NUSKHURI_TOP = 1666,
    AF_BLUE_STRING_GEORGIAN_NUSKHURI_BOTTOM = 1698,
    AF_BLUE_STRING_GEORGIAN_NUSKHURI_ASCENDER = 1730,
    AF_BLUE_STRING_GEORGIAN_NUSKHURI_DESCENDER = 1762,
    AF_BLUE_STRING_GLAGOLITIC_CAPITAL_TOP = 1794,
    AF_BLUE_STRING_GLAGOLITIC_CAPITAL_BOTTOM = 1826,
    AF_BLUE_STRING_GLAGOLITIC_SMALL_TOP = 1858,
    AF_BLUE_STRING_GLAGOLITIC_SMALL_BOTTOM = 1890,
    AF_BLUE_STRING_GOTHIC_TOP = 1922,
    AF_BLUE_STRING_GOTHIC_BOTTOM = 1962,
    AF_BLUE_STRING_GREEK_CAPITAL_TOP = 1982,
    AF_BLUE_STRING_GREEK_CAPITAL_BOTTOM = 2003,
    AF_BLUE_STRING_GREEK_SMALL_BETA_TOP = 2021,
    AF_BLUE_STRING_GREEK_SMALL = 2039,
    AF_BLUE_STRING_GREEK_SMALL_DESCENDER = 2063,
    AF_BLUE_STRING_GUJARATI_TOP = 2087,
    AF_BLUE_STRING_GUJARATI_BOTTOM = 2119,
    AF_BLUE_STRING_GUJARATI_ASCENDER = 2151,
    AF_BLUE_STRING_GUJARATI_DESCENDER = 2201,
    AF_BLUE_STRING_GUJARATI_DIGIT_TOP = 2234,
    AF_BLUE_STRING_GURMUKHI_BASE = 2254,
    AF_BLUE_STRING_GURMUKHI_HEAD = 2286,
    AF_BLUE_STRING_GURMUKHI_TOP = 2318,
    AF_BLUE_STRING_GURMUKHI_BOTTOM = 2350,
    AF_BLUE_STRING_GURMUKHI_DIGIT_TOP = 2382,
    AF_BLUE_STRING_HEBREW_TOP = 2402,
    AF_BLUE_STRING_HEBREW_BOTTOM = 2426,
    AF_BLUE_STRING_HEBREW_DESCENDER = 2444,
    AF_BLUE_STRING_KANNADA_TOP = 2459,
    AF_BLUE_STRING_KANNADA_BOTTOM = 2503,
    AF_BLUE_STRING_KAYAH_LI_TOP = 2535,
    AF_BLUE_STRING_KAYAH_LI_BOTTOM = 2559,
    AF_BLUE_STRING_KAYAH_LI_ASCENDER = 2579,
    AF_BLUE_STRING_KAYAH_LI_DESCENDER = 2587,
    AF_BLUE_STRING_KAYAH_LI_LARGE_DESCENDER = 2599,
    AF_BLUE_STRING_KHMER_TOP = 2620,
    AF_BLUE_STRING_KHMER_SUBSCRIPT_TOP = 2644,
    AF_BLUE_STRING_KHMER_BOTTOM = 2684,
    AF_BLUE_STRING_KHMER_DESCENDER = 2716,
    AF_BLUE_STRING_KHMER_LARGE_DESCENDER = 2750,
    AF_BLUE_STRING_KHMER_SYMBOLS_WAXING_TOP = 2837,
    AF_BLUE_STRING_KHMER_SYMBOLS_WANING_BOTTOM = 2845,
    AF_BLUE_STRING_LAO_TOP = 2853,
    AF_BLUE_STRING_LAO_BOTTOM = 2885,
    AF_BLUE_STRING_LAO_ASCENDER = 2917,
    AF_BLUE_STRING_LAO_LARGE_ASCENDER = 2933,
    AF_BLUE_STRING_LAO_DESCENDER = 2945,
    AF_BLUE_STRING_LATIN_CAPITAL_TOP = 2969,
    AF_BLUE_STRING_LATIN_CAPITAL_BOTTOM = 2985,
    AF_BLUE_STRING_LATIN_SMALL_F_TOP = 3001,
    AF_BLUE_STRING_LATIN_SMALL_TOP = 3015,
    AF_BLUE_STRING_LATIN_SMALL_BOTTOM = 3031,
    AF_BLUE_STRING_LATIN_SMALL_DESCENDER = 3047,
    AF_BLUE_STRING_LATIN_SUBS_CAPITAL_TOP = 3057,
    AF_BLUE_STRING_LATIN_SUBS_CAPITAL_BOTTOM = 3077,
    AF_BLUE_STRING_LATIN_SUBS_SMALL_F_TOP = 3097,
    AF_BLUE_STRING_LATIN_SUBS_SMALL = 3117,
    AF_BLUE_STRING_LATIN_SUBS_SMALL_DESCENDER = 3153,
    AF_BLUE_STRING_LATIN_SUPS_CAPITAL_TOP = 3173,
    AF_BLUE_STRING_LATIN_SUPS_CAPITAL_BOTTOM = 3204,
    AF_BLUE_STRING_LATIN_SUPS_SMALL_F_TOP = 3233,
    AF_BLUE_STRING_LATIN_SUPS_SMALL = 3259,
    AF_BLUE_STRING_LATIN_SUPS_SMALL_DESCENDER = 3284,
    AF_BLUE_STRING_LISU_TOP = 3295,
    AF_BLUE_STRING_LISU_BOTTOM = 3327,
    AF_BLUE_STRING_MALAYALAM_TOP = 3359,
    AF_BLUE_STRING_MALAYALAM_BOTTOM = 3403,
    AF_BLUE_STRING_MYANMAR_TOP = 3435,
    AF_BLUE_STRING_MYANMAR_BOTTOM = 3467,
    AF_BLUE_STRING_MYANMAR_ASCENDER = 3499,
    AF_BLUE_STRING_MYANMAR_DESCENDER = 3527,
    AF_BLUE_STRING_NKO_TOP = 3559,
    AF_BLUE_STRING_NKO_BOTTOM = 3583,
    AF_BLUE_STRING_NKO_SMALL_TOP = 3598,
    AF_BLUE_STRING_NKO_SMALL_BOTTOM = 3607,
    AF_BLUE_STRING_OL_CHIKI = 3619,
    AF_BLUE_STRING_OLD_TURKIC_TOP = 3643,
    AF_BLUE_STRING_OLD_TURKIC_BOTTOM = 3658,
    AF_BLUE_STRING_OSAGE_CAPITAL_TOP = 3678,
    AF_BLUE_STRING_OSAGE_CAPITAL_BOTTOM = 3718,
    AF_BLUE_STRING_OSAGE_CAPITAL_DESCENDER = 3748,
    AF_BLUE_STRING_OSAGE_SMALL_TOP = 3763,
    AF_BLUE_STRING_OSAGE_SMALL_BOTTOM = 3803,
    AF_BLUE_STRING_OSAGE_SMALL_ASCENDER = 3843,
    AF_BLUE_STRING_OSAGE_SMALL_DESCENDER = 3868,
    AF_BLUE_STRING_OSMANYA_TOP = 3883,
    AF_BLUE_STRING_OSMANYA_BOTTOM = 3923,
    AF_BLUE_STRING_SAURASHTRA_TOP = 3963,
    AF_BLUE_STRING_SAURASHTRA_BOTTOM = 3995,
    AF_BLUE_STRING_SHAVIAN_TOP = 4015,
    AF_BLUE_STRING_SHAVIAN_BOTTOM = 4025,
    AF_BLUE_STRING_SHAVIAN_DESCENDER = 4050,
    AF_BLUE_STRING_SHAVIAN_SMALL_TOP = 4060,
    AF_BLUE_STRING_SHAVIAN_SMALL_BOTTOM = 4095,
    AF_BLUE_STRING_SINHALA_TOP = 4110,
    AF_BLUE_STRING_SINHALA_BOTTOM = 4142,
    AF_BLUE_STRING_SINHALA_DESCENDER = 4174,
    AF_BLUE_STRING_SUNDANESE_TOP = 4218,
    AF_BLUE_STRING_SUNDANESE_BOTTOM = 4242,
    AF_BLUE_STRING_SUNDANESE_DESCENDER = 4274,
    AF_BLUE_STRING_TAI_VIET_TOP = 4282,
    AF_BLUE_STRING_TAI_VIET_BOTTOM = 4302,
    AF_BLUE_STRING_TAMIL_TOP = 4314,
    AF_BLUE_STRING_TAMIL_BOTTOM = 4346,
    AF_BLUE_STRING_TELUGU_TOP = 4378,
    AF_BLUE_STRING_TELUGU_BOTTOM = 4406,
    AF_BLUE_STRING_THAI_TOP = 4434,
    AF_BLUE_STRING_THAI_BOTTOM = 4458,
    AF_BLUE_STRING_THAI_ASCENDER = 4486,
    AF_BLUE_STRING_THAI_LARGE_ASCENDER = 4498,
    AF_BLUE_STRING_THAI_DESCENDER = 4510,
    AF_BLUE_STRING_THAI_LARGE_DESCENDER = 4526,
    AF_BLUE_STRING_THAI_DIGIT_TOP = 4534,
    AF_BLUE_STRING_TIFINAGH = 4546,
    AF_BLUE_STRING_VAI_TOP = 4578,
    AF_BLUE_STRING_VAI_BOTTOM = 4610,
    af_blue_1_1 = 4641,
#ifdef AF_CONFIG_OPTION_CJK
    AF_BLUE_STRING_CJK_TOP = af_blue_1_1 + 1,
    AF_BLUE_STRING_CJK_BOTTOM = af_blue_1_1 + 203,
    af_blue_1_1_1 = af_blue_1_1 + 404,
#ifdef AF_CONFIG_OPTION_CJK_BLUE_HANI_VERT
    AF_BLUE_STRING_CJK_LEFT = af_blue_1_1_1 + 1,
    AF_BLUE_STRING_CJK_RIGHT = af_blue_1_1_1 + 204,
    af_blue_1_1_2 = af_blue_1_1_1 + 405,
#else
    af_blue_1_1_2 = af_blue_1_1_1 + 0,
#endif /* AF_CONFIG_OPTION_CJK_BLUE_HANI_VERT */
    af_blue_1_2 = af_blue_1_1_2 + 0,
#else
    af_blue_1_2 = af_blue_1_1 + 0,
#endif /* AF_CONFIG_OPTION_CJK                */


    AF_BLUE_STRING_MAX   /* do not remove */

  } AF_Blue_String;


  FT_LOCAL_ARRAY( char )
  af_blue_strings[];


  /*************************************************************************/
  /*************************************************************************/
  /*****                                                               *****/
  /*****                 B L U E   S T R I N G S E T S                 *****/
  /*****                                                               *****/
  /*************************************************************************/
  /*************************************************************************/

  /* The next level is to group blue strings into style-specific sets. */


  /* Properties are specific to a writing system.  We assume that a given  */
  /* blue string can't be used in more than a single writing system, which */
  /* is a safe bet.                                                        */
#define AF_BLUE_PROPERTY_LATIN_TOP       ( 1U << 0 )  /* must have value 1 */
#define AF_BLUE_PROPERTY_LATIN_SUB_TOP   ( 1U << 1 )
#define AF_BLUE_PROPERTY_LATIN_NEUTRAL   ( 1U << 2 )
#define AF_BLUE_PROPERTY_LATIN_X_HEIGHT  ( 1U << 3 )
#define AF_BLUE_PROPERTY_LATIN_LONG      ( 1U << 4 )

#define AF_BLUE_PROPERTY_CJK_TOP    ( 1U << 0 )       /* must have value 1 */
#define AF_BLUE_PROPERTY_CJK_HORIZ  ( 1U << 1 )       /* must have value 2 */
#define AF_BLUE_PROPERTY_CJK_RIGHT  AF_BLUE_PROPERTY_CJK_TOP


#define AF_BLUE_STRINGSET_MAX_LEN  8

  /* The AF_Blue_Stringset enumeration values are offsets into the */
  /* `af_blue_stringsets' array.                                   */

  typedef enum  AF_Blue_Stringset_
  {
    AF_BLUE_STRINGSET_ADLM = 0,
    AF_BLUE_STRINGSET_ARAB = 5,
    AF_BLUE_STRINGSET_ARMN = 9,
    AF_BLUE_STRINGSET_AVST = 16,
    AF_BLUE_STRINGSET_BAMU = 19,
    AF_BLUE_STRINGSET_BENG = 22,
    AF_BLUE_STRINGSET_BUHD = 27,
    AF_BLUE_STRINGSET_CANADIAN_SYLLABICS = 32,
    AF_BLUE_STRINGSET_CARI = 39,
    AF_BLUE_STRINGSET_CHER = 42,
    AF_BLUE_STRINGSET_COPT = 49,
    AF_BLUE_STRINGSET_CPRT = 54,
    AF_BLUE_STRINGSET_CYRL = 59,
    AF_BLUE_STRINGSET_DEVA = 65,
    AF_BLUE_STRINGSET_DSRT = 71,
    AF_BLUE_STRINGSET_ETHI = 76,
    AF_BLUE_STRINGSET_GEOR = 79,
    AF_BLUE_STRINGSET_GEOK = 84,
    AF_BLUE_STRINGSET_GLAG = 91,
    AF_BLUE_STRINGSET_GOTH = 96,
    AF_BLUE_STRINGSET_GREK = 99,
    AF_BLUE_STRINGSET_GUJR = 106,
    AF_BLUE_STRINGSET_GURU = 112,
    AF_BLUE_STRINGSET_HEBR = 118,
    AF_BLUE_STRINGSET_KALI = 122,
    AF_BLUE_STRINGSET_KNDA = 128,
    AF_BLUE_STRINGSET_KHMR = 131,
    AF_BLUE_STRINGSET_KHMS = 137,
    AF_BLUE_STRINGSET_LAO = 140,
    AF_BLUE_STRINGSET_LATN = 146,
    AF_BLUE_STRINGSET_LATB = 153,
    AF_BLUE_STRINGSET_LATP = 160,
    AF_BLUE_STRINGSET_LISU = 167,
    AF_BLUE_STRINGSET_MLYM = 170,
    AF_BLUE_STRINGSET_MYMR = 173,
    AF_BLUE_STRINGSET_NKOO = 178,
    AF_BLUE_STRINGSET_NONE = 183,
    AF_BLUE_STRINGSET_OLCK = 184,
    AF_BLUE_STRINGSET_ORKH = 187,
    AF_BLUE_STRINGSET_OSGE = 190,
    AF_BLUE_STRINGSET_OSMA = 198,
    AF_BLUE_STRINGSET_SAUR = 201,
    AF_BLUE_STRINGSET_SHAW = 204,
    AF_BLUE_STRINGSET_SINH = 210,
    AF_BLUE_STRINGSET_SUND = 214,
    AF_BLUE_STRINGSET_TAML = 218,
    AF_BLUE_STRINGSET_TAVT = 221,
    AF_BLUE_STRINGSET_TELU = 224,
    AF_BLUE_STRINGSET_THAI = 227,
    AF_BLUE_STRINGSET_TFNG = 235,
    AF_BLUE_STRINGSET_VAII = 238,
    af_blue_2_1 = 241,
#ifdef AF_CONFIG_OPTION_CJK
    AF_BLUE_STRINGSET_HANI = af_blue_2_1 + 0,
    af_blue_2_1_1 = af_blue_2_1 + 2,
#ifdef AF_CONFIG_OPTION_CJK_BLUE_HANI_VERT
    af_blue_2_1_2 = af_blue_2_1_1 + 2,
#else
    af_blue_2_1_2 = af_blue_2_1_1 + 0,
#endif /* AF_CONFIG_OPTION_CJK_BLUE_HANI_VERT */
    af_blue_2_2 = af_blue_2_1_2 + 1,
#else
    af_blue_2_2 = af_blue_2_1 + 0,
#endif /* AF_CONFIG_OPTION_CJK                */


    AF_BLUE_STRINGSET_MAX   /* do not remove */

  } AF_Blue_Stringset;


  typedef struct  AF_Blue_StringRec_
  {
    AF_Blue_String  string;
    FT_UShort       properties;

  } AF_Blue_StringRec;


  FT_LOCAL_ARRAY( AF_Blue_StringRec )
  af_blue_stringsets[];

/* */

FT_END_HEADER


#endif /* AFBLUE_H_ */


/* END */
